// usbdriver.h

#pragma once


using namespace System;

namespace USB {

	public ref class USBDriver
	{


	public:

		USBDriver()
		{
		}

		short Open(DWORD Instance, char* vid_pid, char* outpipe, char* inpipe)
		{
			short sRet;

			sRet = LoadDLL();

			if (sRet == 0)
			{
							 // Always a good idea to initialize the handles
				myOutPipe = myInPipe = INVALID_HANDLE_VALUE;
				
				if (outpipe != NULL)
				{
					myOutPipe = MPUSBOpen(Instance,vid_pid,outpipe,MP_WRITE,0);

					if (myOutPipe == INVALID_HANDLE_VALUE)
						return -5;
				}

				if (inpipe != NULL)
				{
					myInPipe = MPUSBOpen(Instance,vid_pid,inpipe,MP_READ,0);

					if (myInPipe == INVALID_HANDLE_VALUE)
						return -5;
				}

			}

			return sRet;
		}

		void Close()
		{

			// Always check to close all handles before exiting!
			if (myOutPipe != INVALID_HANDLE_VALUE) MPUSBClose(myOutPipe);
			if (myInPipe != INVALID_HANDLE_VALUE) MPUSBClose(myInPipe);
			myOutPipe = myInPipe = INVALID_HANDLE_VALUE;

			// Always check to close the library too.
			if (libHandle != NULL) FreeLibrary(libHandle);

		}

		short Read(BYTE* receive_buf, DWORD buflen, DWORD timeout )
		{
			DWORD reclen;

			MPUSBRead(myInPipe,receive_buf, buflen, &reclen, timeout);
			return reclen;
		}

		short Write(BYTE* send_buf, DWORD buflen, DWORD timeout)
		{
			DWORD sentlen;

			MPUSBWrite(myOutPipe,send_buf,buflen,&sentlen,timeout);
			return sentlen;
		}
	

		// Global Vars
	private:

		DWORD temp;

		HINSTANCE libHandle;
		HANDLE myOutPipe;
		HANDLE myInPipe;
		// TODO: Add your methods for this class here.


short LoadDLL(void)
{
    libHandle = NULL;
    libHandle = LoadLibrary(L"mpusbapi");
    if(libHandle == NULL)
    {
		return -1;
    }
    else
    {
        MPUSBGetDLLVersion=(DWORD(*)(void))\
                    GetProcAddress(libHandle,"_MPUSBGetDLLVersion");
        MPUSBGetDeviceCount=(DWORD(*)(PCHAR))\
                    GetProcAddress(libHandle,"_MPUSBGetDeviceCount");
        MPUSBOpen=(HANDLE(*)(DWORD,PCHAR,PCHAR,DWORD,DWORD))\
                    GetProcAddress(libHandle,"_MPUSBOpen");
        MPUSBWrite=(DWORD(*)(HANDLE,PVOID,DWORD,PDWORD,DWORD))\
                    GetProcAddress(libHandle,"_MPUSBWrite");
        MPUSBRead=(DWORD(*)(HANDLE,PVOID,DWORD,PDWORD,DWORD))\
                    GetProcAddress(libHandle,"_MPUSBRead");
        MPUSBReadInt=(DWORD(*)(HANDLE,PVOID,DWORD,PDWORD,DWORD))\
                    GetProcAddress(libHandle,"_MPUSBReadInt");
        MPUSBClose=(BOOL(*)(HANDLE))GetProcAddress(libHandle,"_MPUSBClose");

        if((MPUSBGetDeviceCount == NULL) || (MPUSBOpen == NULL) ||
            (MPUSBWrite == NULL) || (MPUSBRead == NULL) ||
            (MPUSBClose == NULL) || (MPUSBGetDLLVersion == NULL) ||
            (MPUSBReadInt == NULL))
            return -2;
    }//end if else
	return 0;
}//end LoadDLL

//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

short CheckInvalidHandle(void)
{
    if(GetLastError() == ERROR_INVALID_HANDLE)
    {
        // Most likely cause of the error is the board was disconnected.
        MPUSBClose(myOutPipe);
        MPUSBClose(myInPipe);
        myOutPipe = myInPipe = INVALID_HANDLE_VALUE;
		return 0;
    }//end if
    else
        return (short)GetLastError();
}//end CheckInvalidHandle

//---------------------------------------------------------------------------


	};
}
