using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Collections;

namespace USB
{
    public class USBWrapper
    {
        private USBDriver drv;

        public USBWrapper()
        {
            drv = new USBDriver();
        }

        public short Write(byte[] buf, int timeout)
        {
            short sRet = 0;

            unsafe
            {
                fixed (byte* pbuf = buf)
                {
                    sRet = drv.Write(pbuf, (uint)buf.Length, (uint)timeout);
                }
            }

            return sRet;
        }

        public short Read(ref byte[] buf, int timeout)
        {
            short sRet = 0;

            unsafe
            {
                fixed (byte* pbuf = buf)
                {
                    sRet = drv.Read(pbuf, (uint)buf.Length, (uint)timeout);
                }
            }

            return sRet;
        }

        public short Open(int instance, string vid_pid, string outpipe, string inpipe, bool multithread)
        {
            short sRet = 0;

            byte[] bvid_pid = System.Text.Encoding.ASCII.GetBytes(vid_pid);
            byte[] boutpipe = System.Text.Encoding.ASCII.GetBytes(outpipe);
            byte[] binpipe = System.Text.Encoding.ASCII.GetBytes(inpipe);

            unsafe
            {
                fixed (byte* pvid_pid = bvid_pid, poutpipe = boutpipe, pinpipe = binpipe)
                {
                    sRet = drv.Open((uint)instance, (sbyte*)pvid_pid, (sbyte*)poutpipe, (sbyte*)pinpipe);
                }
            }

            return sRet;
        }

        public void Close()
        {
            drv.Close();
        }
    }
}
